/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2007-2009 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: sh2a_config.h 697 2007-12-25 04:43:57Z honda $
 */

/*
 *		ץå¸⥸塼SH2Aѡ
 *
 *  Υ󥯥롼ɥեϡsh7xxx_config.hʤޤϡ饤
 *  롼ɤեˤΤߤ饤󥯥롼ɤ롥¾Υե뤫
 *  ľܥ󥯥롼ɤƤϤʤʤ
 */

#ifndef TOPPERS_SH2A_CONFIG_H
#define TOPPERS_SH2A_CONFIG_H

/*
 *  μ
 */
#define SH2A

/*
 *  ѤǤ̿᥻å
 *  SH1̿ˤĤƤϡ٤ƤΥǥݡȤΤǡ
 *  ʤ
 */
#define TOPPERS_SUPPORT_SH2_INSTRUCTION
#define TOPPERS_SUPPORT_SH2E_INSTRUCTION
#define TOPPERS_SUPPORT_SH2A_INSTRUCTION

/*
 *  IRQߤɤȽꤹ뤿Υޥ
 *  prc_config.h٤Υեx_config_intatr()
 *  ǻѤ뤿ᡢ˵ҤƤ롣
 */
#define INTNO_IS_IRQ(intno) 								\
		((TMIN_INTNO_IRQ <= (intno)) && ((intno) <= TMAX_INTNO_IRQ))

/*
 *  ֹ椫IRQֹؤѴ
 */
#define INTNO_TO_IRQNO(intno) (((intno) - TMIN_INTNO_IRQ))


#ifndef TOPPERS_MACRO_ONLY

#include "sil.h"

/*
 * IRCν
 */
Inline void
irc_initialize(void)
{
    sil_wrh_mem((void*)ICR0, 0x0000U);
    sil_wrh_mem((void*)ICR1, 0x0000U);
    
#ifdef USE_BANKED_REG
    /*
     * NMI,UBCʳΤ٤Ƥγߤǥ쥸Х󥯤λѤ
     * 쥸Х󥯡Сե㳰
     */
    sil_wrh_mem((void*)IBNR, (IBNR_BE0 | IBNR_BOVE));
#else
    /* 쥸Х󥯻Ѷػ */
    sil_wrh_mem((void*)IBNR, 0x0000U);
#endif /* USE_BANKED_REG */

    init_ipr();	/*  ͥ٥쥸ν  */
}


/*
 *  ߤ°
 */
Inline void
x_config_intatr(INTNO intno, ATR intatr)
{
    /*
     *  IRQΤߥݡȤ
     */
    if(INTNO_IS_IRQ(intno)){
        uint32_t icr1_val = sil_reh_mem((void*)ICR1);
        uint32_t offset   = INTNO_TO_IRQNO(intno) * 2U;

        /*
         *  åȥꥬλ꤬ʤСǥեȤǥ٥ȥꥬ
         *  Ȥ롣
         *  ӥåȤ򥯥ꥢޤޤǤС٥ȥꥬȤʤ롣
         */
        icr1_val &=  ~(0x03U << offset);
        
        if((intatr & TA_POSEDGE) != 0U) {
            /*
             *  ݥƥ֥å
             */
            icr1_val |= IRQ_POSEDGE << offset;
        }

        /*
         *  åȥꥬǡλ꤬ʤСͥƥ֥å
         *  Ȥ롣
         */
        if(((intatr & TA_NEGEDGE) != 0U) ||
           (((intatr & TA_EDGE) != 0U) && ((intatr & TA_BOTHEDGE) == 0U))) {
            /*
             *  ͥƥ֥å
             */
            icr1_val |= IRQ_NEGEDGE << offset;
        }
        
        sil_wrh_mem((void*)ICR1, icr1_val);
    }
}

/*
 *  ߥϥɥɬפIRC
 *
 *  IRQߤǤĥåȥꥬξϳ׵򥯥ꥢ롥
 *  åȥꥬ٥ȥꥬȽ̤ȥСإåɤ礭Τǡ
 *  ˥ꥢ롥
 *  ʥ٥ȥꥬǥꥢ򤷤ƤⳲϤʤ
 *
 *  IRQRR쥸١ߡ꡼ɤơ ӥåȤ0񤭹ࡣ
 *  δ֡ߥå֤ˤƤΤϡʲΤ褦ʥɤ
 *  ᡣ
 *
 *  3γߤͤ롣
 *  ͥ٤ϡl > m > nνȤ롣
 *  ʳlͥ٤⤤
 *  
 *  1.  mγߤȯ(mӥåȤå)
 *  2.  mγߥϥɥ餬¹(nϳ߶ػ)
 *  3.  IRQRR꡼(l = 0, m = 1, n = 0)
 *  4.  lγߤȯ(lӥåȤå)
 *  5.  lγߥϥɥ餬¹(nϳ߶ػ)
 *  6.  nγߤȯα(nӥåȤå)
 *  7.  IRQRR꡼(l = 1, m = 1, n = 1)
 *  8.  IRQRR饤(l = 0, m = 1, n = 1)
 *  9.  lγߥϥɥ齪λ
 *  10. mγߥϥɥƳ
 *  11. IRQQ饤(l = 0, m = 0, n = 0)
 *  
 *  11ʳ n ꥢǽ롥
 */
Inline void
i_begin_int(INTNO intno)
{
    SIL_PRE_LOC;
    uint32_t irqpr, bitptn;
    if (INTNO_IS_IRQ(intno)) {
        /*
         * ١ߡ꡼ɤơ ӥåȤ0񤭹ࡣ
         *  ѿbitptnѤƤΤϡߥåζ֤
         *  û뤿
         */
        bitptn = ~(0x01U << INTNO_TO_IRQNO(intno));
        SIL_LOC_INT();
        irqpr = sil_reh_mem((void *)IRQRR);
        irqpr &= bitptn;
        sil_wrh_mem((void *)IRQRR, irqpr);
        SIL_UNL_INT();
    }
}

#endif /* TOPPERS_MACRO_ONLY */

/*
 *  ץå¸⥸塼SH12Aѡ
 */
#include "sh12a_gcc/prc_config.h"

#endif /* TOPPERS_SH2A_CONFIG_H */
